// PIC24EP256MC202
// fileioCuɂSDJ[h̏݃eXg
#include <xc.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//#include <PPS.h>                   // Pin Re-Mapping peripheral library
// __delay_ms/__delay_usׂ̈ɕKv
#define FCY 60000000UL             // Fosc/2(60MIPS)
#include <libpic30.h>

#include "skSDfileio.h"
#include "skI2Clib.h"
#include "skI2CLCDlib.h"


// RtBM[V̐ݒ
// FICD
#pragma config ICS    = PGD1       // In-Circuit Debuggers̒ʐM`ĺiPGEC1PGED1ŒʐM܂)
#pragma config JTAGEN = OFF        // JTAG ͎gpȂ
// FPOR
#pragma config ALTI2C1 = ON        // I2C1ŎgpśAASDA1/ASCL1gp
#pragma config ALTI2C2 = ON        // I2C2ŎgpśAASDA2/ASCL2gp
#pragma config WDTWIN  = WIN25     // EIb`hbO25%EChËƂ
// FWDT
#pragma config WDTPOST = PS32768   // Watchdog Timer Postscaler bits (1:32,768)
#pragma config WDTPRE  = PR128     // Watchdog Timer Prescaler bit (1:128)
#pragma config PLLKEN  = ON        // PLLbN܂őҋ@APLLNbN֐؂芷܂
#pragma config WINDIS  = OFF       // EIb`hbOɃEChE͎gȂ
#pragma config FWDTEN  = OFF       // EIb`hbO̗L/"SWDTEN"rbgōs
// FOSC
#pragma config POSCMD   = NONE     // OIV[^̓샂[h̑I (OIV[^͎gȂ)
#pragma config OSCIOFNC = ON       // OSC2s@\̑I (OSC2s̓fW^I/OƂ)
#pragma config IOL1WAY  = OFF      // Ӌ@̃st͉xłύXolɋ
#pragma config FCKSM    = CSDCMD   // NbN̊ĎNbNؑւ͂Ȃ
// FOSCSEL
#pragma config FNOSC   = FRCPLL    // IV[^PLL삳
#pragma config PWMLOCK = ON        // PWM Lock Enable bit (Certain PWM registers may only be written after key sequence)
#pragma config IESO    = OFF       // FosĉQiK؂ւł̋N͂Ȃ
// FGS
#pragma config GWRP = OFF          // General Segment Write-Protect bit (General Segment may be written)
#pragma config GCP  = OFF          // General Segment Code-Protect bit (General Segment Code protect is Disabled)


// Some sample data to write to the file
char sampleData[] = "DATA,123\r\n";

int main(void)
{
     FILEIO_ERROR_TYPE sts ;
     SDINIT_ERROR_TYPE sd_ans ;
     FILEIO_OBJECT file;
     char buf[12] ;
     int ans , len ;

     ///////////////////////////////////////////////////////////////////////////
     // MCȔlݒs                                             //
     ///////////////////////////////////////////////////////////////////////////
     _SWDTEN = 0 ;                 // EIb`hbO͖
     // VXeNbN̐ݒ(Fosc=120MHz FCY=60MHz/60MIPS)
     // Fosc=FRC*(M/(N1*N2))  M=PLLDIV+2  N1=PLLPRE+2  N2=2*(PLLPOST+1)
     // Fosc=7.37*(65/(2*2))=119.7625(120MHz)  FCY=120/2=60MIPS
     _FRCDIV  = 0b000 ;            //  FRC|XgXP[(ȂF7.37MHz)
     _PLLPRE  = 0b00000 ;          // PLL̓̓vXP[[N1=2](QF7.37/2=3.685MHz)
     _PLLDIV  = 63 ;               // PLL̃tB[hobNl[M=65]
     _PLLPOST = 0b00 ;             // PLL̏o̓|XgXP[[N2=2](Ȃ)
     // Wait for PLL to lock
     while (OSCCONbits.LOCK!= 1) ;
     // I/O̐ݒ
     ANSELA = 0b0000000000000000 ; // AN0,1AiO͎gpȂAfW^I/OɊ
     ANSELB = 0b0000000000000000 ; // AN2-5AiO͎gpȂAfW^I/OɊ
     TRISA  = 0b0000000000000000 ; // RA0-RA4Sďo͂ɐݒA1œ 0ŏo
     TRISB  = 0b0000001001100011 ; // RB0,RB1/RB5,RB6(I2C2)/RB9(SDI1)͓́Ȃ͏o͂ɐݒ
     CNPUB  = 0b0000000001100011 ; // RB0(CD),RB1(WP),RB5(ASDA2),RB6(ASCL2)̓vAbvs
     PORTA  = 0b0000000000000000 ; // o̓s̏(SLOWɂ)
     PORTB  = 0b0000000000010000 ; // o̓s̏(SLOWɂ)ARB4(SPI-CS)=HIGH
     // S̊荞݂̋ݒ
     _IPL     = 0 ;                // CPŮݗD惌xݒ(D惌xOȏ)
     _GIE     = 1 ;                // S荞ݏ

     ///////////////////////////////////////////////////////////////////////////
     // Ӌ@\̏ݒs                                          //
     ///////////////////////////////////////////////////////////////////////////
     // I2CʐM̃}X^[[hŏsAʐMx400KHz
     InitI2C_Master(1) ;
     // I2Cڑ^LCDW[̏
     // ICON OFF,RgXg(0-63),VDD=3.3VŎg,LCD8
     LCD_Init(LCD_NOT_ICON,35,LCD_VDD3V,8) ;
     LCD_Puts("SDC TEST") ;

     // 3bɊJn
     __delay_ms(3000) ;

     ///////////////////////////////////////////////////////////////////////////
     // C̏                                                          //
     ///////////////////////////////////////////////////////////////////////////

     // rcJ[h̏s
     sd_ans = SD_Init('A') ;
     if (sd_ans == SDINIT_ERROR_NONE) {
          // 
          // t@Č[珑݃[hŊJ(t@Cꍇ͍쐬)
          // t@CLꍇ́At@Cɒǉ݂
          ans = FILEIO_Open(&file, "TEST.CSV", FILEIO_OPEN_WRITE | FILEIO_OPEN_APPEND | FILEIO_OPEN_CREATE) ;
          if (ans == FILEIO_RESULT_SUCCESS) {
               len = strlen(sampleData) ;
               // f[^1s
               if (FILEIO_Write(sampleData, 1, len, &file) == len) {
                    LCD_SetCursor(0,0) ;
                    LCD_Puts("WriteOK!") ;
               }
               // t@C̃N[Y
               FILEIO_Close(&file) ;
          }
          // rcJ[h̏Iƌʂ̕\s
          sts = SD_Termination('A') ;
          LCD_SetCursor(0,1) ;
          if (sts == FILEIO_ERROR_NONE) LCD_Puts("Success ") ;
          else {
               sprintf(buf,"ERno=%d\0",sts) ;
               LCD_Puts(buf) ;
          }
     } else {
          // s
          LCD_SetCursor(0,1) ;
          LCD_Puts("InitERR!") ;
     }

     // End of program
     while(1) ;
}
