/*******************************************************************************
*  skI2Clib.h - I2CʐMs֐̃CN[ht@C(16rbgMCUp)       *
*               (PIC 24EP256MC202)                                             *
*                                                                              *
* ============================================================================ *
*  VERSION DATE        BY                    CHANGE/COMMENT                    *
* ---------------------------------------------------------------------------- *
*  1.00    2015-07-27  ޒH[(ނ)  Create                            *
*  2.00    2016-07-15  ޒH[(ނ)  foCX̃WX^Ǐ֐ǉ*
*******************************************************************************/
#ifndef _SKI2CLIB_H_
#define _SKI2CLIB_H_


#ifndef FCY
  // Unless already defined assume 60MHz(60MIPS) system frequency
  #define FCY 60000000UL      // Fosc/2(60MIPS)
  #include <libpic30.h>
#endif

// 萔̒`
#define ACK   0
#define NOACK 1
#define RW_0  0
#define RW_1  1

#define BUS_COLLISION_RETRY 15     // oX̏Փˎ̃gC

#define I2C_MSSP2_USE    // I2C2𗘗pꍇ̓RgO܂B
// hQbW[̃WX^[`
#ifdef  I2C_MSSP2_USE
// I2C2(MSSP2)𗘗pꍇ̒`
#define I2C_CON          I2C2CON
#define I2C_STAT         I2C2STAT
#define I2C_TRN          I2C2TRN
#define I2C_RCV          I2C2RCV
#define I2C_BRG          I2C2BRG
#define I2C_MIF          _MI2C2IF
#define I2C_MIE          _MI2C2IE
#define I2C_MIP          _MI2C2IP
#define I2C_STAT_BCL     I2C2STATbits.BCL
#define I2C_STAT_RBF     I2C2STATbits.RBF
#define I2C_STAT_ACKSTAT I2C2STATbits.ACKSTAT
#define I2C_CON_DISSLW   I2C2CONbits.DISSLW
#define I2C_CON_SEN      I2C2CONbits.SEN
#define I2C_CON_RSEN     I2C2CONbits.RSEN
#define I2C_CON_PEN      I2C2CONbits.PEN
#define I2C_CON_RCEN     I2C2CONbits.RCEN
#define I2C_CON_ACKDT    I2C2CONbits.ACKDT
#define I2C_CON_ACKEN    I2C2CONbits.ACKEN
#else
// I2C1(MSSP1)𗘗pꍇ̒`
#define I2C_CON          I2C1CON
#define I2C_STAT         I2C1STAT
#define I2C_TRN          I2C1TRN
#define I2C_RCV          I2C1RCV
#define I2C_BRG          I2C1BRG
#define I2C_MIF          _MI2C1IF
#define I2C_MIE          _MI2C1IE
#define I2C_MIP          _MI2C1IP
#define I2C_STAT_BCL     I2C1STATbits.BCL
#define I2C_STAT_RBF     I2C1STATbits.RBF
#define I2C_STAT_ACKSTAT I2C1STATbits.ACKSTAT
#define I2C_CON_DISSLW   I2C1CONbits.DISSLW
#define I2C_CON_SEN      I2C1CONbits.SEN
#define I2C_CON_RSEN     I2C1CONbits.RSEN
#define I2C_CON_PEN      I2C1CONbits.PEN
#define I2C_CON_RCEN     I2C1CONbits.RCEN
#define I2C_CON_ACKDT    I2C1CONbits.ACKDT
#define I2C_CON_ACKEN    I2C1CONbits.ACKEN
#endif

// ֐̃vg^Cv錾
void InitI2C_Master(int speed) ;
int  I2C_Start(int adrs,int rw) ;
int  I2C_rStart(int adrs,int rw) ;
int  I2C_Stop( void ) ;
int  I2C_Send(char dt) ;
int  I2C_Receive(int ack) ;

int I2C_SlaveRead(int slv_adrs,char reg_adrs,unsigned char *data,char kosu) ;
int I2C_SlaveWrite(int slv_adrs,char reg_adrs,unsigned char *data,char kosu) ;

#endif
